//
//  LIFEReproStep.m
//  Copyright (C) 2017 Buglife, Inc.
//  
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//  
//       http://www.apache.org/licenses/LICENSE-2.0
//  
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.
//
//

#import "LIFEReproStep.h"

@implementation LIFEReproStep

- (instancetype)init
{
    self = [super init];
    if (self) {
        _userDescription = @"";
    }
    return self;
}

#pragma mark - NSCoding

- (instancetype)initWithCoder:(NSCoder *)coder
{
    self = [super init];
    if (self) {
        _userDescription = [coder decodeObjectForKey:@"userDescription"];
    }
    return self;
}

- (void)encodeWithCoder:(NSCoder *)coder
{
    [coder encodeObject:_userDescription forKey:@"userDescription"];
}

#pragma mark - Public methods

- (BOOL)isEmpty
{
    NSCharacterSet *whitespaceCharacters = [NSCharacterSet whitespaceAndNewlineCharacterSet];
    NSString *trimmedString = [_userDescription stringByTrimmingCharactersInSet:whitespaceCharacters];
    return trimmedString.length == 0;
}

@end
