//
//  LIFEContextAwareLogFormatter.h
//  Copyright (C) 2017 Buglife, Inc.
//  
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//  
//       http://www.apache.org/licenses/LICENSE-2.0
//  
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.
//
//

// Software License Agreement (BSD License)
//
// Copyright (c) 2010-2016, Deusty, LLC
// All rights reserved.
//
// Redistribution and use of this software in source and binary forms,
// with or without modification, are permitted provided that the following conditions are met:
//
// * Redistributions of source code must retain the above copyright notice,
//   this list of conditions and the following disclaimer.
//
// * Neither the name of Deusty nor the names of its contributors may be used
//   to endorse or promote products derived from this software without specific
//   prior written permission of Deusty, LLC.


#import <Foundation/Foundation.h>
#import "LIFELog.h"

#pragma mark - Logging contexts

// These are logs for internal Buglife SDK development,
// and should *only* get logged to the console when debugging,
// or when Buglife.debugMode is true
static const NSInteger LIFELogContextSDKInternal = 100;

// These are logs generated by the Buglife SDK, that are developer-facing
// (i.e. they do get logged to the console, ASL & filesystem)
static const NSInteger LIFELogContextSDKExternal = 101;

// These shouldn't get logged to the console, or ASL
static const NSInteger LIFELogContextNotification = 110;
static const NSInteger LIFELogContextUserEvent = 111;

// If SDK consumers are using CocoaLumberjack, then we only want to
// write logs to our file (don't need to log to console or ASL, because
// the user is probably alread doing this directly w/ CocoaLumberjack)
static const NSInteger LIFELogContextCocoaLumberjack = 1;

@interface LIFEContextAwareLogFormatter : NSObject <LIFELogFormatter>

@end
